''' functions to read out available properties and methods in an object'''

def listProperties(object):
  ''' print all properties in the given object '''

  try:
    properties = object.Properties
    
    print 'Properties'
    print '---------------------'
    
    for i, property in enumerate(properties):
      print '%i: %s: %s' %(i + 1, property.Name, property.Value)
     
    print '---------------------'
  except:
    print 'No Properties'

def Methods(object):
  ''' return a list of all methods callable from given the object '''
  
  return [method for method in dir(object) if callable(getattr(object, method))]

def listMethods(object):
  ''' print all methods callable from the given object '''

  try:
    methods = Methods(object)

    if len(methods) == 0:
      raise ValueError
    
    print 'Methods'
    print '---------------------'
    
    for i, method in enumerate(methods):
      print '%i: %s' % (i + 1, method)
      
    print '---------------------'
  except:
    print 'No methods'

def listPropertiesAndMethods(object):
  ''' print all properties and methods from the given object '''

  listProperties(object)
  listMethods(object)